import 'package:wyatt_architecture/wyatt_architecture.dart';
import 'package:wyatt_cloud_messaging_bloc/src/domain/entities/remote_notifications.dart';

abstract class NotificationRemoteDataSource extends BaseRepository {
  Future<void> register();

  Future<Stream<RemoteNotification>> onNotificationAccepted();

  Future<Stream<RemoteNotification>> onNotificationBackgroundAccepted();

  Future<Stream<RemoteNotification>> onNotificationForegroundAccepted();

  Future<void> requestPermissions();

  Future<String> getToken();

  Future<void> subscribeToTopic(String topic);

  Future<void> unsubscribeFromTopic(String topic);
}
