import 'dart:async';

import 'package:wyatt_architecture/wyatt_architecture.dart';
import 'package:wyatt_cloud_messaging_bloc/src/domain/entities/remote_notifications.dart';

abstract class NotificationRepository extends BaseRepository {
  FutureOrResult<void> register();

  FutureOrResult<Stream<RemoteNotification>> onNotificationAccepted();

  FutureOrResult<Stream<RemoteNotification>> onNotificationBackgroundAccepted();

  FutureOrResult<Stream<RemoteNotification>> onNotificationForegroundAccepted();

  FutureOrResult<void> requestPermissions();

  FutureOrResult<String> getToken();

  FutureOrResult<void> subscribeToTopic(String topic);

  FutureOrResult<void> unsubscribeFromTopic(String topic);
}
