import 'dart:async';

import 'package:wyatt_architecture/wyatt_architecture.dart';
import 'package:wyatt_cloud_messaging_bloc/src/domain/repositories/notification_repository.dart';

class Subscribe extends AsyncUseCase<String, void> {
  final NotificationRepository _notificationRepository;

  Subscribe({required NotificationRepository notificationRepository})
      : _notificationRepository = notificationRepository;

  @override
  FutureOr<void> onStart(String? params) {
    if (params == null) {
      throw const ClientException('Topic is not valid');
    }
  }

  @override
  FutureOrResult<void> execute(String? params) =>
      _notificationRepository.subscribeToTopic(params!);
}
